%global _hardened_build 1

%define commit          5a40efd002ca7a9d608484e7a17c6b23b809e827
%define shortcommit     %(c=%{commit}; echo ${c:0:7})
%define _release        8

Name:           duc
Version:        1.4.4
%if 0%{?commit:1}
Release:        %{_release}.git%{shortcommit}%{?dist}
Source0:        https://github.com/zevv/duc/archive/%{commit}.tar.gz
%else
Release:        %{_release}%{?dist}
Source0:        https://github.com/zevv/duc/releases/download/%{version}/%{name}-%{version}.tar.gz
%endif
Summary:        Collection of tools for inspecting and visualizing disk usage
License:        LGPLv3
URL:            https://duc.zevv.nl
Source1:        ducrc
Source2:        duc.sysconfig
Source3:        duc.systemd
Source4:        duc.timer
Source5:        ducrc.root
Source9:        duc.systemd.user

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  systemd
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  cairo-devel
BuildRequires:  pango-devel
BuildRequires:  ncurses-devel
BuildRequires:  glfw-devel
BuildRequires:  leveldb-devel
#BuildRequires:  sqlite-devel
#BuildRequires:  tokyocabinet-devel
#BuildRequires:  lmdb-devel

%description
%{summary}

%package selinux
BuildArch:              noarch

Source6:                %{name}.fc
Source7:                %{name}.if
Source8:                %{name}.te

BuildRequires:          selinux-policy-devel
Requires:               %{name}

Requires(post):         policycoreutils
Requires(post):         policycoreutils-python 
Requires(postun):       policycoreutils
Requires(post):         systemd
Requires(preun):        systemd
Requires(postun):       systemd

Summary: SELinux policy for %{name}

%description selinux
%{summary}

%prep
%if 0%{?commit:1}
%autosetup -p1 -n %{name}-%{commit}
%else
%autosetup -p1 -n %{name}-%{version}
%endif
mkdir -p selinux
cp %{SOURCE6} %{SOURCE7} %{SOURCE8} selinux

%build
cd selinux
make -f /usr/share/selinux/devel/Makefile %{name}.pp || exit
cd -

autoreconf -i
%set_build_flags
%configure \
  --with-db-backend=leveldb
# (tokyocabinet,leveldb,sqlite3,lmdb,kyotocabinet
%make_build

%install
%make_install
install -Dp %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}rc
install -Dp %{SOURCE5} %{buildroot}/root/.%{name}rc
install -Dp %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -Dp %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
install -Dp %{SOURCE4} %{buildroot}%{_unitdir}/%{name}.timer
install -Dp %{SOURCE9} %{buildroot}%{_userunitdir}/%{name}.service

install -Dp selinux/%{name}.pp %{buildroot}%{_datadir}/selinux/packages/%{name}.pp
install -Dp selinux/%{name}.if %{buildroot}%{_datadir}/selinux/devel/include/contrib/%{name}.if

%clean
make distclean

%preun
%systemd_preun %{name}.service

%post
%systemd_post %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%defattr(-,root,root,-)
#license LICENSE
%doc ChangeLog
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*
%config(noreplace) %{_sysconfdir}/%{name}rc
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) /root/.%{name}rc
%{_unitdir}/%{name}.service
%{_userunitdir}/%{name}.service
%{_unitdir}/%{name}.timer

%files selinux
%{_datadir}/selinux/packages/%{name}.pp
%{_datadir}/selinux/devel/include/contrib/%{name}.if

%post selinux
semodule -n -i %{_datadir}/selinux/packages/%{name}.pp
if /usr/sbin/selinuxenabled ; then
    /usr/sbin/load_policy
    /usr/sbin/fixfiles -R %{name} restore
fi;
exit 0

%postun selinux
if [ $1 -eq 0 ]; then
    semodule -n -r %{name}
    if /usr/sbin/selinuxenabled ; then
       /usr/sbin/load_policy
       /usr/sbin/fixfiles -R %{name} restore
    fi;
fi;
exit 0

%changelog
* Tue Oct 22 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-9.git5a40efd
- revises rc files and systemd script
* Thu Oct 17 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-8.git5a40efd
- revises SELinux policy
- adds systemd user script
* Sat Oct 12 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-7.git5a40efd
- adds SELinux policy
* Sat Oct 05 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-6.git5a40efd
- bump to latest git version
* Sat Sep 28 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-5.git04ea642
- bump to latest git version (04ea642)
* Fri Sep 20 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-4
- changes service type
* Sat Sep 07 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-3
- typo correction
* Sat Sep 07 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-2
- switches to leveldb
- adds rc file
- adds systemd timer
* Fri Sep 06 2019 Robert Führicht <robert.fuehricht@jku.at> - 1.4.4-1
- initial packaging
